"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.describeAPIMetricsOnce = void 0;
const config_1 = require("../../config");
const commonLabels = [
    'queueName',
    'userAgent',
    'apiVersion',
    'state',
    'statusCode',
];
let described = false;
const describeAPIMetricsOnce = (metrics) => {
    if (described) {
        return;
    }
    described = true;
    metrics.describe.counter('api_arrival_total', 'number of arrivals to the api', {
        labelNames: [...commonLabels],
    });
    metrics.describe.histogram('api_bytes_read', 'histogram of bytes read on the socket for each request', {
        buckets: config_1.bytesRWBuckets,
        labelNames: [...commonLabels],
    });
    metrics.describe.histogram('api_bytes_written', 'histogram of bytes written on the socket for each request', {
        buckets: config_1.bytesRWBuckets,
        labelNames: [...commonLabels],
    });
    metrics.describe.histogram('api_latency_seconds', 'histogram of time spent to process a request from arrival to completion', {
        buckets: config_1.latencyBuckets,
        labelNames: [...commonLabels],
    });
};
exports.describeAPIMetricsOnce = describeAPIMetricsOnce;
//# sourceMappingURL=describe.js.map