import type * as express from 'express';
import type * as prometheus from 'prom-client';
import type { AggregatorStrategy } from './enums';
export interface LabelSet {
    [name: string]: string;
}
export interface CustomParams {
    percentiles?: number[];
    buckets?: number[];
    labelNames?: string[];
    aggregator?: AggregatorStrategy;
}
export declare class MetricConstructor<T extends string = string, U extends any[] = any[]> {
    construct: new (...args: U) => prometheus.Metric<T>;
    constructor(construct: new (...args: U) => prometheus.Metric<T>);
    create(...args: U): prometheus.Metric<T>;
}
export interface MetricsMap<T extends string = string> {
    gauge: {
        [name: string]: prometheus.Gauge<T>;
    };
    counter: {
        [name: string]: prometheus.Counter<T>;
    };
    histogram: {
        [name: string]: prometheus.Histogram<T>;
    };
    summary: {
        [name: string]: prometheus.Summary<T>;
    };
}
export declare type Kind = keyof MetricsMap;
export interface MetricsMeta {
    kind: Kind;
    help: string;
    customParams: CustomParams;
}
export interface MetricsMetaMap {
    [name: string]: MetricsMeta;
}
export declare type AuthTestFunc = (req: express.Request) => boolean;
